// Simple JavaScript text hilighter
// 
// Extremely experimental... only works on some pages
// Some code borrowed from http://www.nsftools.com/misc/SearchAndHighlight.htm
// 

function doHighlight(bodyText, searchTerm, bgColor, fgColor) {
	highlightStartTag = '<span style="color:' + fgColor + '; background-color:' + bgColor + ';">';
	highlightEndTag = '</span>';
	
	var newText = "";
	var i = -1;
	var lcSearchTerm = searchTerm.toLowerCase();
	var lcBodyText = bodyText.toLowerCase();
    
	while (bodyText.length > 0) {
		i = lcBodyText.indexOf(lcSearchTerm, i+1);
		if (i < 0) {
			newText += bodyText;
			bodyText = "";
		} else {
			// skip anything inside an HTML tag
			if (bodyText.lastIndexOf(">", i) >= bodyText.lastIndexOf("<", i)) {
				// skip anything inside a <script> block
				if (lcBodyText.lastIndexOf("/script>", i) >= lcBodyText.lastIndexOf("<script", i)) {
					newText += bodyText.substring(0, i) + highlightStartTag + bodyText.substr(i, searchTerm.length) + highlightEndTag;
					bodyText = bodyText.substr(i + searchTerm.length);
					lcBodyText = bodyText.toLowerCase();
					i = -1;
				}
			}
		}
	}
	
	return newText;
}

function highlightTerm(term, bgColor, fgColor) {
	document.body.innerHTML = doHighlight(document.body.innerHTML, term, bgColor, fgColor); 
}